/*!
* @file ItemTemplate.h
* @brief アイテムのステータステンプレート
* @date 2014/04/04
* @author Deskull
* 2014 Sikabane Works.
*/

#pragma once

#include "stdafx.h"
#include "Deeangband.h"

#include "Dice.h"
#include "Effect.h"
#include "GameElement.h"
#include "SavingTable.h"


namespace Deeangband
{

	/*!
	* @class ItemTemplate
	* @brief アイテムのクラス
	*/
	class ItemTemplate : public GameElement
	{
	private:

		Dice baseDamage; //!< ベースダメージのダイス
		WEIGHT weight; //!< アイテムの重量
		SavingTable baseSaving; //!< 基本セービング修正
		SavingTable plusSaving; //!< 追加セービング修正

		friend class boost::serialization::access;

		/*!
		* @brief クラスのシリアライズ化を設定する
		* @param archive アーカイブ化するクラスのアドレス
		* @param version データバージョン
		* @return XMLSerializeテンプレート
		*/
		template<class Archive> void serialize(Archive &archive, const unsigned int version) 
		{
			if(version >= 0)
			{
				archive & BOOST_SERIALIZATION_NVP(baseDamage);
				archive & BOOST_SERIALIZATION_NVP(weight);
				archive & BOOST_SERIALIZATION_NVP(baseSaving);
				archive & BOOST_SERIALIZATION_NVP(plusSaving);
			}
		}

	public:

		/*! 
		* @brief ItemTemplateクラスコンストラクタ(GameElementメンバ対応)
		* @param id GameElementのID
		* @param tag GameElementのタグ
		* @param gameWorld 所属元gameWorld参照ポインタ
		*/
		ItemTemplate::ItemTemplate(ID id, TAG tag, GameWorld *gameWorld);

		/*! 
		* @brief ItemTemplateクラスコンストラクタ
		*/
		ItemTemplate::ItemTemplate(void);

		/*! 
		* @brief ItemTemplateクラスデストラクタ
		*/
		ItemTemplate::~ItemTemplate(void);

		/*! 
		* @brief ダミーデータによる初期化
		* @return なし
		*/
		void ItemTemplate::SetDammyData(void);

		/*! 受けた効果を処理する */
		bool ItemTemplate::TakeEffect(Effect *effectPtr, POWER amount);

		/*! 基本装甲修正を返す */
		AC ItemTemplate::GetBaseAC(void);

		/*! 追加装甲修正を返す */
		AC ItemTemplate::GetPlusAC(void);

		/*! 基本回避修正を返す */
		EV ItemTemplate::GetBaseEV(void);

		/*! 追加回避修正を返す */
		EV ItemTemplate::GetPlusEV(void);

		/*! 基本意志修正を返す */
		VO ItemTemplate::GetBaseVO(void);

		/*! 追加意志修正を返す */
		VO ItemTemplate::GetPlusVO(void);

		/*!
		* @brief XMLシリアライズによるゲームデータ保存処理
		* @return なし
		*/
		void ItemTemplate::XMLSave(std::string filename);

	};

}